/* start of include files */
#include <plib.h>
#include <wlib.h>
#include <hwif.h>

/* end of include files */

/* start of structure definitions */

/* initial data */
struct mydata {
	TEXT myaddr[50] ;
	TEXT mypath[P_FNAMESIZE] ;
	} ;
/* how large should the header lines be */
#define HDRLEN 100	
/* linked list data definitions */
struct ll {
   TEXT datafile[13] ; /* <name>.<ext>\0 where name is upto 8 chars and ext is 3 chars, total 11 plis the . and the \0 gives 13 */
   TEXT to[HDRLEN] ;
   TEXT from[HDRLEN] ;
   TEXT subject[HDRLEN] ;
   TEXT cc[HDRLEN] ;
   TEXT bcc[HDRLEN] ;
   INT status ;
   INT read ;
   INT no ;
   INT count ;
   struct mydata * mydata ;
   struct ll * next ;
   } ;

/* end of struct definitions */


/* start of defines */

/* #define RUNONSUN */

/* list printing definitions */
#define PDATAFILE 0x1
#define PTO 0x2
#define PFROM 0x4
#define PSUBJECT 0x8
#define PCC 0x10
#define PBCC 0x20
#define PSTATUS 0x40
#define PREAD 0x80
#define PNO 0x100
#define PCOUNT 0x200
#define PACTIVE 0x400
#define PIGNORE 0x800
#define PDELETED 0x1000
/* general defines */
#define TRUE 1
#define FALSE 0
#define FILEERR -1
#define MEMERR -2
#define IERR -3

/* locations of the meta files */
#define METAIN "LOC::M:\\MAILDIR\\IN.MTA"
#define METAOUT "LOC::M:\\MAILDIR\\OUT.MTA"

/* location of the word app */
#define MAILRDRCMD "ROM::WORD.APP"
/* the name to match the name on the system screen
   as this is compiled into the alias file it is probabaly not something you
   will change unless you also rename the mailrdr.ma and mailrdr.pic files
   as well as changing the mailrdr.ma file */
#define MAILRDRNAME "Mailrdr"
#define MAILRDREXT ".msg"
/* default name for output files */
#define OUTSKELETON "OUT%d.MSG"

/* max line length */
#define MAXLINE 1024
/* ll status values */
#define ACTIVE 0
#define IGNORE -1
#define DELETED -2
/* ll new / read */
#define RD -1
#define NEW -2


/* max number of outgoing emails */
#define MAXEMAILOUT 100

/* stuff relating to the number of lines in the header window */
#define ITEMS_ON_SCREEN 5
#define ITEMS_ON_HALF_SCREEN 2

/* how much to increase the y location when printing the headers */
#define HDRINCR 11

/* End of defines */

/* Start of Global data */

/* pointers to the in and out list and the list we are currently working on */
struct ll * inlist ;
struct ll * outlist ;
struct ll * currlist ;

/* menu stuff, first define the commands array */
LOCAL_D TEXT *cmds[]= {
	"vView Current", /* these will go under the Current Functions submenu */
	"dDelete Current",
	"uUndelete Current",
	"mModify Header",
	"nNew Email", /* these will go under the Compose submenu */
	"rReply to sender",
	"aReply to all",
	"xExit and save state", /* these will go under the special menu */
	"cExit and lose state",
	"sSwitch between lists",
	NULL };
/* this defines how the commands menu will be presented */
LOCAL_D H_MENU_DATA mdata[] = {
	"Current Email", 4,
	"Compose",3,
	"Special",3,
	NULL };
	
/* pointers to the arrays. DO NOT CHANGE THESE NAMES OR DEFINITIONS as they
   are used by the psion ROM to do menus etc. */
GLDEF_D TEXT ** _cmds=(&cmds[0]) ;
GLDEF_D H_MENU_DATA * _mdata=(&mdata[0]) ;
/* the current mail number */
INT mailno ; 

/* the main window */
UINT MainWid ;

/* the status window */
W_WINDATA wdstatus ;
UINT gcstatus ;
G_GC gdstatus ;
INT winstatus ;
/* the headers window */
W_WINDATA wdhdr ;
UINT gchdr ;
G_GC gdhdr ;
INT winhdr ;

/* used to remove waste from the end of a line */
TEXT * blank = "                                       " ;

/* End of Global data */

/* Start of function definitions */

/* main and top level functions */
VOID main(VOID);
VOID doword(TEXT * fname) ;
VOID initwins(VOID) ;
VOID initmywins(VOID) ;
VOID dogreet(VOID) ;
INT initlist(VOID) ;
INT mainloop(VOID) ;
INT dotidy(VOID) ;
VOID shutwins(VOID) ;
LOCAL_C VOID ManageCommand(INT keycode) ; /* decide what to do with a command */
/* these functions relate to the window stuff */
VOID statusmsg(TEXT * str) ;
VOID redolist(VOID) ;
INT askincl(VOID) ; /* ask if we want to include the current email */
/* the following relate to the commands for modifying the mailbox in view */
VOID readmail(INT mailno, struct ll * llptr) ; /* bring up a viewer */
VOID wrtemail(INT mailno, struct ll * llptr) ; /* wtite / reply */
VOID delmail (INT mailno, struct ll * llptr) ; /* delete the mail from the internal linked lists */
VOID udelmail (INT mailno, struct ll * llptr) ; /* undelete the mail from the internal linked lists */

/* stuff for starting / other processes */
INT buildcmd(TEXT cmdbyte, TEXT * appname, TEXT * appext, TEXT * appalias, TEXT * fname, TEXT * cmdline) ;
INT runcmd(TEXT * appname, TEXT * cmdline, INT cmdlen) ;

/* the following are commands that work on the mailbox files */
INT delfile(struct ll * llcur, struct ll * llstart) ; /* delete the actual email file */
INT newfile(struct ll * llcur, struct ll * llstart) ; /* create a new empty email file and return the name */
INT cpyfile (struct ll * newll, struct ll * outhead, struct ll * origll, struct ll * inhead) ;/* cpyfile - copy from the file in origll to the file in newll assume the file exists */
INT fileexist(TEXT * fname) ; /* does the file given in fname exist return TRUE or FALSE if any other error than E_FILE_NXIST return FILEERR */



/* the following work on the meta file */
INT readmeta(TEXT * fname, struct ll * itemlist) ; /* read in the data descriptions */
INT wrtmeta(TEXT * fname, struct ll * itemlist) ; /* write the data descriptions out */
INT readhdr(VOID * fd, struct ll * itemlist) ; /* read the from, subject and return path etc from the data file */
INT wrthdr(VOID * fd, struct ll * itemlist) ; /* write a subject and destination etc to the data file */
INT getf(VOID * fd, TEXT * line) ; /* read a line of text from file handle */
INT putf(VOID * fd, TEXT * line) ; /* write a line of text to file handle */

/* commands to manipulate the linked list */
struct ll * llnew(VOID) ;
struct ll * llnofind(INT no, struct ll * llstart) ;
VOID llfill(struct ll * llptr, TEXT * datafile, TEXT * to, TEXT * from, TEXT * subject, TEXT * cc, TEXT * bcc, INT status, INT read, INT no) ;
VOID llfree (struct ll * llptr) ;
VOID lladd(struct ll * newll, struct ll * startll) ;
VOID llinit(VOID);
VOID llcopy(struct ll * out, struct ll * in) ; /* copy the strings in an entry */
INT prgemail(struct ll * llptr) ;
VOID llprint(struct ll * startll, INT mask, INT startno, INT endno); /* print the list at start ll, according to the mask, between the numbers startno and end no */
VOID llprinta(struct ll * llptr, INT mask, TEXT * str) ; /* print the ll structure according to the mask */
VOID disphdrs(struct ll * llptr) ; /* display the usual header information */
INT llvalid(INT mailno, struct ll * llptr) ; /* is mailno in the list and marked as ACTIVE ? */
VOID lldump(struct ll * llptr) ; /* print the current ll entry */
VOID lldmpall(struct ll * llptr) ; /* print the entire ll list */


/* functions for reading headers from the user */
VOID gethdr(struct ll * in) ; /* fill in a data entry with user information */

/* functions for creating new emails and replys */
INT newemail(INT mailno, struct ll * startll, INT incl) ; /* newemail, new list entry, fill it in then write the email */
INT repall(INT mailno, struct ll * startll, INT incl) ; /* repall, reply to the sender and all other recievers */
INT repfrom(INT mailno, struct ll * startll, INT incl) ; /* repfrom, reply to the sender only */


/* End of function definitions */

/* start of actual code */

/* start of linked list code */

/* display the usual header information */
VOID disphdrs(struct ll * llptr) 
{
	INT mask, startno, endno ;
	/* if llptr is inlist include from, otherwise include to */
	if (llptr == inlist)
		mask = PFROM | PREAD ;
	else
		mask = PTO ;
	/* add the other stuff */
	mask = mask | PNO | PSUBJECT | PACTIVE | PDELETED | PSTATUS ;
	/* try to print ITEMS_ON_SCREEN emails we check for sanity of startno and endno later*/
	startno = mailno - ITEMS_ON_HALF_SCREEN ;
	endno = mailno + ITEMS_ON_HALF_SCREEN ;
	/* if we are at the begining print the first ITEMS_ON_SCREEN emails */
	if (mailno <= ITEMS_ON_HALF_SCREEN)
	{
		startno = 1 ;
		endno = ITEMS_ON_SCREEN ;
	}
	if ((mailno + ITEMS_ON_HALF_SCREEN) >= currlist->count) 
	{
		endno = currlist->count ;
		startno = (endno - ITEMS_ON_SCREEN) +1 ;
	}
	/* check for sanity in the start and end numbers */
	if (startno < 1)
		startno = 1;
	if (endno > currlist->count)
		endno = currlist->count ;
	llprint(llptr, mask, startno, endno) ;
}
/* print the list at start ll, according to the mask, between the numbers startno and end no */
VOID llprint(struct ll * startll, INT mask, INT startno, INT endno) 
{
	TEXT tmp[200], tmp1[300] ;
	INT ystart,doprint, prtct ;
	G_GC gc ;
	ystart = HDRINCR ;
	prtct = 0 ;
	while (startll != NULL)
	{
		doprint = FALSE ;
		if ((startll->no >= startno) && (startll->no <= endno))
		{
			/* should we be printing this record ? */
			if ((mask & PACTIVE) && (startll->status == ACTIVE))
			{
				llprinta(startll, mask, tmp) ;
				doprint = TRUE ;
			}
			else if ((mask & PIGNORE) && (startll->status == IGNORE))
			{
				llprinta(startll, mask, tmp) ;
				doprint = TRUE ;
			}
			else if ((mask & PDELETED) && (startll->status == DELETED))
			{
				llprinta(startll, mask, tmp) ;
				doprint = TRUE ;
			}
		}
		if (doprint == TRUE)
		{
			prtct ++ ;
			if (mailno == startll->no) /* this line needs to be in bold */
			{
				gc.style = G_STY_NORMAL | G_STY_BOLD ;
				gSetGC(gchdr, G_GC_MASK_STYLE, &gc) ;
			}
			else /* not the current email */
			{
				gc.style = G_STY_NORMAL ;
				gSetGC(gchdr, G_GC_MASK_STYLE, &gc) ;
			}
			p_scpym(tmp1, tmp, blank, NULL) ; /* remove any chars at the end of the line */
			gPrintClipText(5, ystart, tmp1, p_slen(tmp1), 230) ;
			ystart += HDRINCR ;
		}
		startll = startll->next ;
	}
	/* empty out the other stuff on the screen */
	if ( prtct < ITEMS_ON_SCREEN)
	{
		p_scpym(tmp1, blank, blank, NULL) ;
		while (prtct < ITEMS_ON_SCREEN)
		{
			gPrintClipText(5, ystart, tmp1, p_slen(tmp1), 230) ;
			ystart += HDRINCR ;
			prtct ++ ;
		}
	}
}

/* print the structure according to the mask */
VOID llprinta(struct ll * llptr, INT mask, TEXT * str)
{
	TEXT outline[1024] ;
	TEXT tmp[100] ;
	outline[0] = '\0' ;
	/* print llptr according to the mask */
	if (mask & PNO)
	{
		p_atos(tmp, "%d", llptr->no) ;
		p_scatm(outline, tmp, " ", NULL) ;
	}
	if (mask & PREAD)
	{
		if (llptr->read == RD)
			p_scatm(outline, "R", " ", NULL) ;
		else
			p_scatm(outline, "N", " ", NULL) ;
	}
	if (mask & PSTATUS)
	{
		if (llptr->status == ACTIVE)
			p_scatm(outline, " ", " ", NULL) ;
		else if (llptr->status == IGNORE)
			p_scatm(outline, "I", " ", NULL) ;
		else if (llptr->status == DELETED)
			p_scatm(outline, "D", " ", NULL) ;
	}
	if (mask & PDATAFILE)
		p_scatm(outline, llptr->datafile, " ", NULL) ;
	if (mask & PTO)
		p_scatm(outline, llptr->to, " ", NULL) ;
	if (mask & PFROM)
		p_scatm(outline, llptr->from, " ", NULL) ;
	if (mask & PSUBJECT)
		p_scatm(outline, ": ",llptr->subject, " ", NULL) ;
	if (mask & PCC)
		p_scatm(outline, llptr->cc, " ", NULL) ;
	if(mask & PBCC)
		p_scatm(outline, llptr->bcc, " ", NULL) ;
	if (mask & PCOUNT)
	{
		p_atos(tmp, "%d", llptr->count) ;
		p_scatm(outline, tmp, " ", NULL) ;
	}
	p_scpy(str, outline) ;
}
/* this command scans the linked lists looking for a deleted entry. the associated file is then deleted */
INT prgemail(struct ll * llptr)
{
	struct ll * llstart ;
	INT ret ;
	llstart = llptr ;
	while(llptr != NULL)
	{
		if(llptr->status == DELETED)
		{
			ret = delfile(llptr, llstart) ;
			if (ret == FILEERR)
			{
				uDisplayText("FILE ERROR: prgemail,","error in deleting message file", llptr->datafile, NULL) ;
				return(FILEERR) ;
			}
		}
		llptr = llptr->next ;
	}
	return(TRUE) ;
}
/* fill in a ll entry based on the arguments */
VOID llfill(struct ll * llptr, TEXT * datafile, TEXT * to, TEXT * from, TEXT * subject, TEXT * cc, TEXT * bcc, INT status, INT read, INT no)
{
	p_scpy(llptr->datafile, datafile) ;
	p_scpy(llptr->to, to) ;
	p_scpy(llptr->from, from) ;
	p_scpy(llptr->subject, subject) ;
	p_scpy(llptr->cc, cc) ;
	p_scpy(llptr->bcc, bcc) ;
	llptr->status = status ;
	llptr->read = read ;
	llptr->no = no ;
}
/* find a list entry based on the number */
struct ll * llnofind(INT no, struct ll * llstart)
{
	struct ll * llcurrnt ;
	llcurrnt = llstart ;
	while(llcurrnt->no != no)
	{
		if(llcurrnt->next == NULL)
		{
			return(NULL) ;
		}
		llcurrnt = llcurrnt->next ;

	}
	/* to have got here we must havea match if we could not find a match we would already havereturned NULL */
	return(llcurrnt) ;
}
		
/* this adds the newll to the end of the list at startll */
VOID lladd(struct ll * newll, struct ll * startll)
{
	struct ll * llcurrnt ;
	llcurrnt = startll ;
	/* scan down the list lokking for NULL) */
	while(llcurrnt->next != NULL)
	{
		llcurrnt = llcurrnt->next ;
	}
	/* we are at the end of the list add the entry */
	llcurrnt->next = newll ;
	/* increment the total in the list counter, held in the first entry in the list only */
	startll->count ++ ;
}
/* this function creates the initial in and out list entries */
VOID llinit(VOID)
{
	inlist = llnew() ;
	outlist = llnew() ;
	inlist->mydata = p_alloc(sizeof(struct mydata)) ;
	outlist->mydata = p_alloc(sizeof(struct mydata)) ;
}

/* linked list functions */
/* llnew, create space and fill with defaults */
struct ll * llnew(VOID)
{
	struct ll * llptr;
	llptr = p_alloc(sizeof(struct ll)) ;
	llptr->datafile[0] = '\0' ;
	llptr->to[0] = '\0' ;
	llptr->from[0] = '\0' ;
	llptr->subject[0] = '\0' ;
	llptr->cc[0] = '\0' ;
	llptr->bcc[0] = '\0' ;
	llptr->status = IGNORE ;
	llptr->read = NEW ;
	llptr->next = NULL ;
	llptr->no = 0 ;
	llptr->count = 0 ;
	llptr->mydata = NULL ;
	return(llptr) ;
}
VOID llcopy (struct ll * out, struct ll * in)
{
	/* copy the strings but status etc remains untouched */
	p_scpy(out->datafile, in->datafile) ;
	p_scpy(out->to, in->to) ;
	p_scpy(out->from, in->from) ;
	p_scpy(out->subject, in->subject) ;
	p_scpy(out->cc, in->cc) ;
	p_scpy(out->bcc, in->bcc) ;
}
/* llfree, free llptr and everything it points to */
VOID llfree (struct ll * llptr) 
{
	struct ll * llnext;
	/* free the mydata section only on the first item */
	p_free(llptr->mydata) ;
	llnext = llptr;
	while(llptr != NULL)
	{
		llnext = llptr->next ;
		p_free(llptr) ;
		llptr = llnext ;
	}
}
/* is mailno in the list and marked as ACTIVE ? */
INT llvalid(INT mailno, struct ll * llptr)
{
	TEXT tmp[50] ;
	llptr = llnofind(mailno, llptr) ;
	if (llptr != NULL)
	{
		if (llptr->status != ACTIVE)
		{
			p_atos(tmp, "%d is not an active message", mailno) ;
			uDisplayText(tmp, NULL) ;
			return(FALSE) ;
		}
		else
		{
			return(TRUE) ;
		}
	}
	else
	{
		p_atos(tmp, "%d is not a valid message", mailno) ;
		uDisplayText(tmp, NULL) ;
		return(FALSE) ;
	}
}

/* end of linked list code */

/* start of top level functions */

/* create the graphics context */
VOID CreateGC(VOID)
{
	INT hgc ;
	hgc = gCreateGC0(MainWid) ;
	if (hgc < 0)
		p_exit(hgc) ;
}
/* do the basic window setup */
VOID initwins(VOID)
{

	uCommonInit() ; /* connect to the window system etc */
	MainWid=uFindMainWid() ; /* figure out what the main window is */
	CreateGC() ;
	hCrackCommandLine() ; /* do the command line and make 
	                                   ourselves available for recieveing 
	                                   commands such as exit etc */
}

/* setup the windows etc. */
VOID initmywins(VOID)
{
	/* create the windows */
	/* the status window */
	/* geometry information */
	wdstatus.extent.tl.x = 0 ;
	wdstatus.extent.tl.y = 0 ;
	wdstatus.extent.width = 240 ;
	wdstatus.extent.height = 18 ;
	wdstatus.flags = W_WIN_PRIORITY ;
	wdstatus.mouse_icon = 0 ;
	wdstatus.filler = 0 ;
	wdstatus.background = W_WIN_BACK_BITMAP ;
	/* graphics context definitions (how to draw) specification */
	gdstatus.gmode = G_TRMODE_SET ;
	gdstatus.textmode = G_TRMODE_REPL ;
	gdstatus.style = G_STY_NORMAL ;
	gdstatus.filler = 0 ;
	gdstatus.font = WS_FONT_BASE ;
	/* create the window */
	winstatus = wCreateWindow(MainWid, W_WIN_EXTENT | W_WIN_BACKGROUND, &wdstatus,1) ;
	/* make it real in the windows tree */
	wInitialiseWindowTree(winstatus) ;
	/* create the graphics context */
	gcstatus = gCreateGC(winstatus, G_GC_MASK_GMODE | G_GC_MASK_TEXTMODE | G_GC_MASK_STYLE, &gdstatus) ;
	/* make the window visible */
	wMakeVisible(winstatus) ;
	/* make the current context the one we will use */
	gSetGC0(gcstatus) ;
	/* put a border around the current context */
	gBorder(W_BORD_CUSHION|W_BORD_CORNER_4) ;
	
	/* the header window */
	/* geometry information */
	wdhdr.extent.tl.x = 0 ;
	wdhdr.extent.tl.y = 21 ;
	wdhdr.extent.width = 240 ;
	wdhdr.extent.height = 59 ; 
	wdhdr.flags = W_WIN_PRIORITY ;
	wdhdr.mouse_icon = 0 ;
	wdhdr.filler = 0 ;
	wdhdr.background = W_WIN_BACK_BITMAP ;
	/* graphics context definitions (how to draw) specification for normal text */
	gdhdr.gmode = G_TRMODE_SET ;
	gdhdr.textmode = G_TRMODE_REPL ;
	gdhdr.style = G_STY_NORMAL ;
	gdhdr.filler = 0 ;
	gdhdr.font = WS_FONT_BASE ;
	/* create the window */
	winhdr = wCreateWindow(MainWid, W_WIN_EXTENT | W_WIN_BACKGROUND, &wdhdr,1) ;
	/* make it real in the windows tree */
	wInitialiseWindowTree(winhdr) ;
	/* create the graphics context for normal text */
	gchdr = gCreateGC(winhdr, G_GC_MASK_GMODE | G_GC_MASK_TEXTMODE | G_GC_MASK_STYLE, &gdhdr) ;	
	/* make the window visible */
	wMakeVisible(winhdr) ;
	/* make the current context the one we will use */
	gSetGC0(gchdr) ;
	/* put a border around the current context */
	gBorder(W_BORD_CUSHION|W_BORD_CORNER_4) ;
	
}


/* close down the windows */
VOID shutwins(VOID) 
{
	/* shutdown any windows etc */
	wCloseWindowTree(MainWid) ;
}

/* print out who we are and the version number */
VOID dogreet(VOID)
{
	uDisplayText("Psion Offline SMTP Mail Reader", "(C) by Tim Graves,","Sun Microsystems","Version 2.7", "Press Return to continue", NULL) ;
}

/* read the incomming meta file and display the list of emails */
INT initlist(VOID)
{
	INT ret ;
	llinit() ;
	statusmsg("Reading mta lists") ;
	/* first read the incomming meta data file */
	ret = readmeta(METAIN, inlist) ;
	if (ret == FILEERR)
	{
		uDisplayText("FILE ERROR: initlist,","error in reading metafile", METAIN, NULL) ;
		return (FILEERR) ;
	}
	if (ret == MEMERR)
	{
		uDisplayText("MEMORY ERROR: initlist,","error in reading metafile", METAIN, NULL) ;
		return(MEMERR) ;
	}
	/* then the outgoing data file */
	ret = readmeta(METAOUT, outlist) ;
	if (ret == FILEERR)
	{
		uDisplayText("FILE ERROR: initlist,","error in reading metafile", METAIN, NULL) ;
		return (FILEERR) ;
	}
	if (ret == MEMERR)
	{
		uDisplayText("MEMORY ERROR: initlist,","error in reading metafile", METAOUT, NULL) ;
		return(MEMERR) ;
	}
	/* start working with the incomming list */
	currlist = inlist ;
	if (currlist->count > 0)
		mailno = 1 ;
	else
		mailno = 0 ;
	/* display the list first*/
	redolist() ;
	return(TRUE) ;
}

/* wait for a command then do it this is taken directly from the 
   developers kit demo code */
INT mainloop(VOID)
{
	INT ret ;
	WMSG_KEY key ;
	FOREVER
	{
		uGetKey(&key) ;
		if (key.keycode&W_EVENT_KEY) /* call from the system screen, we are only interested in the shutdown
		 				as we done accept new or open functions */
		{
			if (key.keycode==CONS_EVENT_COMMAND) /* exit and save our state */
				return(TRUE) ;
		}
		else if (key.keycode&W_SPECIAL_KEY) /* psion-? accelerator */
		{
			/* check for x or q (exit and save or crash out) as we handle these here */
			ret = key.keycode&(~W_SPECIAL_KEY) ;
			if (ret == 'x')
				return (TRUE) ;
			else if (ret == 'c')
				return(IERR) ;
			else
				ManageCommand(ret) ;
		}
		else if ((key.keycode == W_KEY_MENU) && !(key.modifiers&W_CTRL_MODIFIER)) /* menu button */
		{
			ret = uPresentMenus() ;
			if (ret > 0)
			{
				/* check for x or q (exit and save or crash out) as we handle these here */
				if (ret == 'x')
					return (TRUE) ;
				else if (ret == 'c')
					return(IERR) ;
				else
					ManageCommand(ret) ;
			}
		}
		/* we know the keycode is not a system screen function, psion-? key on menu button
		   see if it is a movement key (up, down, page up, page down or modified with ctrl */
		else
		{
			switch (key.keycode)
			{
				case W_KEY_UP:
					if (key.modifiers&W_CTRL_MODIFIER) /* go to the bottom of the current page */
						mailno -= ITEMS_ON_HALF_SCREEN ;
					else
						mailno -- ;
					break ;
				case W_KEY_DOWN:
					if (key.modifiers&W_CTRL_MODIFIER) /* go to the top of the current page */
						mailno += ITEMS_ON_HALF_SCREEN  ;
					else
						mailno ++ ;
					break ;
				case W_KEY_PAGE_UP:
					if (key.modifiers&W_CTRL_MODIFIER) /* go to the first entry */
						mailno = 1 ;
					else
						mailno -= ITEMS_ON_SCREEN ;
					break ;
				case W_KEY_PAGE_DOWN:
					if (key.modifiers&W_CTRL_MODIFIER) /* go to the last entry */
						mailno = currlist->count ;
					else
						mailno += ITEMS_ON_SCREEN ;
					break ;
			}
			/* make sure that mail no is within the current email range */
			if (mailno < 1)
				mailno = 1 ;
			if (mailno > currlist->count)
				mailno = currlist->count ;
		}
		redolist() ; /* the likley hood is that the list will have changed so redraw it */
	}
}

LOCAL_C VOID ManageCommand(INT keycode)
{
	INT  incl;
	struct ll * llptr ;
	switch (keycode)
	{
		/* functions from the current email list */
		case 'v': /* v - view the email */
			readmail(mailno, currlist) ;
			break ;
		case 'd': /* d - delete email */
			delmail(mailno, currlist) ;
			break ;
		case 'u': /* u - undelete email */
			udelmail(mailno, currlist) ;
			break ;
		case 'm': /* modify the current header */
			/* this is pointless unless we are dealing with the outgoing list. So */
			if (currlist == inlist)
			{
				uDisplayText("You Cannot modify the headers", "In the incomming list", "(Its a pointless exercise)", NULL) ;
				break ;
			}
			llptr = llnofind(mailno, currlist) ;
			gethdr(llptr) ;
			break ;
		/* functions from the compose email list */
		case 'n': /* new email */
			incl = askincl() ;
			newemail(mailno, currlist, incl) ;
			break ;
		case 'r': /* r - reply to sender */
			incl = askincl() ;
			repfrom(mailno, currlist, incl) ;
			break;
		case 'a': /* a - reply to all */
			incl = askincl() ;
			repall(mailno, currlist, incl) ;
			break ;
		/* functions from the special email list - NOTE x and c are dealt with earlier in the mainloop code */
		case 's': /* s - switch from the inlist to the outlist */
			if (currlist == inlist)
			{
				uDisplayText("Switching to the outgoing mail file", NULL) ;
				currlist = outlist ;
			}
			else
			{
				uDisplayText("Switching to the incomming mail file", NULL) ;
				currlist = inlist ;
			}
			mailno = 1 ;
			break ;
	}
	return ;			
		
}

/* delete any deleted files, write out the updated meta files */
INT dotidy(VOID)
{
	INT ret ;
	/* purge the deleted incomming emails */
	statusmsg("Deleting unwanted message files") ;
	ret = prgemail(inlist) ;
	if (ret == FILEERR)
	{
		return(FILEERR) ;
	}
	/* purge any deleted outgoing emails */
	ret = prgemail(outlist) ;
	if (ret == FILEERR)
	{
		return(FILEERR) ;
	}
	/* write the incomming list back out */
	statusmsg("Saving mta lists") ;
	ret = wrtmeta(METAIN, inlist) ;
	if (ret == FILEERR)
	{
		return(FILEERR) ;
	}
	/* finaly the outgoing list */
	wrtmeta(METAOUT, outlist) ;
	if (ret == FILEERR)
	{
		return(FILEERR) ;
	}
	/* free the data in the list */
	statusmsg("Freeing Memory") ;
	llfree(inlist) ;
	llfree(outlist) ;
	return(TRUE) ;
}
	
	
/* write the meta files out */
 void main(void)
{
	INT ret ;
	/* setup the windows etc*/
	initwins() ;
	/* say Hi */
	dogreet() ;
	/* Load my windows */
	initmywins() ;
	/* read the list of incomming mail */
	ret = initlist() ;
	if (ret == FILEERR)
	{
		uDisplayText("FILE ERROR: main, error","in loading meta lists", NULL) ;
		return ;
	}
	if (ret == MEMERR)
	{
		uDisplayText("MEMORY ERROR: main, error","in loading meta lists", NULL) ;
		return ;
	}
	if (ret != TRUE)
	{
		uDisplayText("UNKNOWN ERROR: main, error","in loading meta lists", NULL) ;
		return ;
	}
	/* main select / chose / do loop */
	ret = mainloop() ;
	if (ret == IERR)
	{
		uDisplayText("INTERNAL ERROR: panic exit","(metafiles not written)", NULL) ;
		return ;
	}
	else if (ret == FILEERR)
	{
		uDisplayText("FILE ERROR: panic exit","(metafiles not written)", NULL) ;
		return ;
	}
	else if (ret == MEMERR)
	{
		uDisplayText("MEMORY ERROR: panic exit","(metafiles not written)", NULL) ;
		return ;
	}
	else if ((ret != TRUE) && (ret != FALSE))
	{
		uDisplayText("UNKNOWN ERROR: panic exit","(metafiles not written)", NULL) ;
		return ;
	}
	/* tidy up after us */
	ret = dotidy() ;
	if (ret == IERR)
	{
		uDisplayText("INTERNAL ERROR: main, error","in writting meta lists", NULL) ;
		return ;
	}
	if (ret == MEMERR)
	{
		uDisplayText("MEMORY ERROR: main, error","in writting meta lists", NULL) ;
		return ;
	}
	if (ret == FILEERR)
	{
		uDisplayText("FILE ERROR: main, error","in writting meta lists", NULL) ;
		return ;
	}
	if (ret != TRUE)
	{
		uDisplayText("UNKNOWN ERROR: main, error","in writting meta lists", NULL) ;
		return ;
	}
	/* close down the windows etc */
	shutwins() ;
}

/* end of top level code */

/* start of process related code */
/* do the word stuff */
VOID doword(TEXT * fname)
{
	TEXT cmdline[127], tmp[50] ;
	INT cmdlen ;

	/* build the command line */
	cmdlen = buildcmd('O',MAILRDRNAME, MAILRDREXT, "Q", fname, cmdline) ;
	p_atos(tmp, "Running %s", MAILRDRNAME ) ;
	statusmsg(tmp) ;
	runcmd(MAILRDRCMD, cmdline, cmdlen) ;
	p_atos(tmp, "Returned from %s", MAILRDRNAME) ;
	statusmsg(tmp) ;
}

INT runcmd(TEXT * appname, TEXT * cmdline, INT cmdlen) 
{
	HANDLE pid ;
	WORD stat ;
	/* create the process */
	if ((pid = p_execc(appname, cmdline, cmdlen)) <0)
		return(pid) ;
	
	/* we want to monitor it */
	p_logona(pid, &stat) ;

	/* start the process up */
	p_presume(pid) ;

	/* wait for it to finish */
	p_waitstat(&stat) ;

	return(stat >> 8) ;
}

INT buildcmd(TEXT cmdbyte, TEXT * appname, TEXT * appext, TEXT * appalias, TEXT * fname, TEXT * cmdline)
{
	TEXT * cmdptr;
	INT cmdlen ;

	/* initialisation */
	cmdlen = 0 ;
	cmdptr = cmdline ;
	/* do the command byte */
		/* insert it */
		* cmdptr = cmdbyte ;
		/* the length has just been increased */
		cmdlen ++ ;
		/* move cmdptr allong one to skip over the command */
		cmdptr ++ ;
	/* insert the appname */
		/* insert it */
		p_scpy(cmdptr, appname) ;
		/* move over it and the \0 */
		cmdptr = cmdptr + p_slen(appname) +1 ;
		/* add the length and the \0 to the total length */
		cmdlen = cmdlen + p_slen(appname) +1 ;
	/* insert the extension and other stuff if appext is non NULL */
	if (appext != NULL)
	{
		/* insert the extension */
		p_scpy(cmdptr, appext) ;
		/* move over it BUT NOT THE NULL (we may have an alias)*/
		cmdptr = cmdptr + p_slen(appext) ;
		/* add the length to the total length */
		cmdlen = cmdlen + p_slen(appext) ;

		/* if the alias is non NULL add it */
		if (appalias != NULL) 
		{
			/* insert a space */
			*cmdptr = ' ' ;
			/* move over the space */
			cmdptr ++ ;
			/* add the space to the total length */
			cmdlen ++ ;
			/* insert the appalias */
			p_scpy(cmdptr, appalias) ;
			/* move over the alias BUT NOT THE NULL (then is dealt with below)*/
			cmdptr = cmdptr + p_slen(appalias) ;
			/* increment the total length */
			cmdlen = cmdlen + p_slen(appalias) ;
		}

		/* because we have not accounted for the \0 at the end of the appext / appext+appalias
		   move over it now */
		cmdptr ++ ;
		cmdlen ++ ;

		/* if there is a filename add it */
		if (fname != NULL)
		{
			/*insert the filename */
			p_scpy(cmdptr, fname) ;
			/* add the length and vF \0 to the total length */
			cmdlen = cmdlen + p_slen(fname) + 1 ;
			/* we done need to move cmdptr as we are at the end of the operatrion */
		}
	}
	/* return with the length of the assembled string */
	return(cmdlen) ;
}

/* end of process related code */

/* start of writting email code */
/* repfrom, reply to the sender only */
INT repfrom(INT mailno, struct ll * startll, INT incl)
{
	struct ll * newll, *repmail ;
	TEXT tmp[100] ;
	INT ret ;
	/* create the new list entry */
	newll = llnew() ;
	/* locate the origional email */
	repmail = llnofind(mailno, startll) ;
	/* copy the data */
	llcopy(newll, repmail) ;
	/* add Reto the start of the subject */
	p_scpym(tmp, "Re: ", newll->subject, NULL) ;
	p_scpy(newll->subject, tmp) ;
	/* copy the from into the to list */
	p_scpy(newll->to, newll->from) ;
	/* put our name in the from field */
	p_scpy(newll->from, startll->mydata->myaddr) ;
	/* empty the cc and bcc fields */
	newll->cc[0] = '\0' ;
	newll->bcc[0] = '\0' ;
	/* create the related file */
	if ((ret = newfile(newll, outlist)) != TRUE)
	{
		p_free(newll) ;
		if (ret == FILEERR)
			uDisplayText("FILE ERROR: repfrom,","newfile returned FILEERR", NULL) ;
		else
			uDisplayText("INTERNAL ERROR: repfrom,","newfile returned an unexpected error code", NULL) ;
		return(ret) ;
	}
	/* if incl is TRUE copy from the origional to the new data file */
	if (incl == TRUE)
	{
		if ((ret = cpyfile(newll,outlist , repmail, startll)) != TRUE)
		{
			p_free(newll) ;
			if (ret == FILEERR)
				uDisplayText("FILE ERROR: repfrom,","cpyfile returned FILEERR", NULL) ;
			else
				uDisplayText("INTERNAL ERROR: repfrom,","cpyfile returned an unexpected error code", NULL) ;
			return(ret) ;
		}
	}
	/* make the email active */
	newll->status = ACTIVE ;
	/* get the header information */
	gethdr(newll) ;
	/* get the sequence number */
	newll->no = outlist->count +1 ;
	/* add this email to the outgoing list */
	lladd(newll, outlist) ;
	/* call the editor do do the work */
	wrtemail(newll->no, outlist) ;
}

/* repall, reply to the sender and all other recievers */
INT repall(INT mailno, struct ll * startll, INT incl)
{
	struct ll * newll, *repmail ;
	TEXT tmp[100] ;
	/* create the new list entry */
	newll = llnew() ;
	/* locate the origional email */
	repmail = llnofind(mailno, startll) ;
	/* copy the data */
	llcopy(newll, repmail) ;
	/* add Reto the start of the subject */
	p_scpym(tmp, "Re: ", newll->subject, NULL) ;
	p_scpy(newll->subject, tmp) ;
	/* add the from to the to list */
	p_scpym(tmp, newll->from, " ", newll->to, NULL) ;
	p_scpy(newll->to, tmp) ;
	/* put our name in the from field */
	p_scpy(newll->from, startll->mydata->myaddr) ;
	/* create the related file */
	if (newfile(newll, outlist)== FALSE)
	{
		p_free(newll) ;
		return(FALSE) ;
	}
	/* if incl is TRUE copy from the origional to the new data file */
	if (incl == TRUE)
		cpyfile(newll, outlist, repmail, startll) ;
	/* make the email active */
	newll->status = ACTIVE ;
	/* get the header information */
	gethdr(newll) ;
	/* get the sequence number */
	newll->no = outlist->count +1 ;
	/* add this email to the outgoing list */
	lladd(newll, outlist) ;
	/* call the editor do do the work */
	wrtemail(newll->no, outlist) ;
}
/* newemail, new list entry, fill it in then write the email */
INT newemail(INT mailno, struct ll * startll, INT incl)
{
	struct ll * newll, * repmail ;
	INT ret ;
	newll = llnew() ;
	/* instal our address into the from field */
	p_scpy(newll->from, startll->mydata->myaddr) ;
	/* create the related file */
	if (newfile(newll, outlist) == FILEERR)
	{
		uDisplayText("FILE ERROR: newemail,","error in creating new email file", NULL) ;
		p_free(newll) ;
		return(FILEERR) ;
	}
	/* if incl is true we need to copy the given email */
	if (incl == TRUE)
	{
		repmail = llnofind(mailno, startll) ;
		ret = cpyfile(newll, outlist, repmail, startll) ;
		if (ret == FILEERR)
		{
			uDisplayText("FILE ERROR: newemail,","error in creating copy file for include", NULL) ;
			return(FILEERR) ;
		}
	}
	/* make the email active */
	newll->status = ACTIVE ;
	/* get the header information */
	gethdr(newll) ;
	/* get the sequence number */
	newll->no = outlist->count +1 ;
	/* add this email to the outgoing list */
	lladd(newll, outlist) ;
	/* call the editor do do the work */
	wrtemail(newll->no, outlist) ;
}
/* end of email writting code */

/* start of header from user code */
/* fill in a data entry with user information */
VOID gethdr(struct ll * in)
{
	TEXT to[HDRLEN+1], subject[HDRLEN+1], cc [HDRLEN+1], bcc[HDRLEN+1] ;
	H_DI_SEDIT eto, esubject, ecc, ebcc ;
	/* convert from zero terminated strings (ala C) to byte count srtings (ala OPL) */
	uZTStoBCS(to, in->to) ;
	uZTStoBCS(subject, in->subject) ;
	uZTStoBCS(cc, in->cc) ;
	uZTStoBCS(bcc, in->bcc) ;
	/* build the dialog structures */
	/* the to structure */
	eto.str = &to[0] ;
	eto.len = HDRLEN ;
	eto.width = 30 ;
	/* subject structure */
	esubject.str = &subject[0] ;
	esubject.len = HDRLEN ;
	esubject.width = 30 ;
	/* cc structure */
	ecc.str = &cc[0] ;
	ecc.len = HDRLEN ;
	ecc.width = 30 ;
	/* bcc structure */
	ebcc.str = &bcc[0] ;
	ebcc.len = HDRLEN ;
	ebcc.width = 30 ;
	
	/* build the dialog */
	uOpenDialog("Please enter the header information") ;
	/* add the initial header information to it */
	uAddDialogItem(H_DIALOG_SEDIT, "To:", &eto) ;
	uAddDialogItem(H_DIALOG_SEDIT, "Subject:", &esubject) ;
	uAddDialogItem(H_DIALOG_SEDIT, "Cc:", &ecc) ;
	uAddDialogItem(H_DIALOG_SEDIT, "Bcc:", &ebcc) ;
	/* run the dialog */
	uRunDialog() ;
	/* unpack the resulting strings this is realy daft having parts of the dialog ZTS and parts BCS */
	/* terminate them first */
	to[((INT)to[0])+1] = '\0' ;
	subject[((INT) subject[0])+1] = '\0' ;
	cc[((INT) cc[0])+1] = '\0' ;
	bcc[((INT) bcc[0]) +1] = '\0' ;
	/* copy the strings back */
	p_scpy(in->to, &to[1]) ;
	p_scpy(in->subject, &subject[1]) ;
	p_scpy(in->cc, &cc[1]) ;
	p_scpy(in->bcc, &bcc[1]) ;	
}

/* end of header from user code */

/* start of functions for working the mailbox in view */
/* bring up a mail reader */
VOID readmail(INT mailno, struct ll * llstart)
{
	struct ll * llentry ;
	TEXT fname [P_FNAMESIZE] ;
	if ((llentry = llnofind(mailno, llstart)) == NULL)
		return ;
	if (llentry->status != ACTIVE)
		return ;
	/* build up the name */
	p_scpym(fname, llstart->mydata->mypath, llentry->datafile, NULL) ;
	/* call up the editor */
	doword(fname) ;
	/* OK we've read the mail, mark it as read */
	llentry->read = RD ;
}
/* write a mail reply, the corresponding linked list
   entry exists as does the file, so ensure that
   it is listed as active after the edit */
VOID wrtemail(INT mailno, struct ll * llstart)
{
	struct ll * llentry ;
	TEXT fname [P_FNAMESIZE] ;
	if((llentry = llnofind(mailno, llstart)) == NULL)
		return ;
	/* build up the name */
	p_scpym(fname, llstart->mydata->mypath, llentry->datafile, NULL) ;
	/* call up the editor */
	doword(fname) ;
	/* OK we've got a file ensure it's active */
	llentry->status = ACTIVE ;
}
/* delete a mail from the linked lists */
VOID delmail (INT mailno, struct ll * llstart)
{
	struct ll * llentry ;
	if ((llentry = llnofind(mailno, llstart)) == NULL)
		return ;
	llentry->status = DELETED ;
}
/* undelete the mail from the internal linked lists */
VOID udelmail (INT mailno, struct ll * llptr)
{
	struct ll * llentry ;
	if ((llentry = llnofind(mailno, llptr)) == NULL)
		return ;
	llentry->status = ACTIVE ;
}
/* end of functions for working the mailbox in view */

/* start of ancilary data file functions */
/* delfile - physicaly delete the data file */
INT delfile(struct ll * llcur, struct ll * llstart)
{
	TEXT dfname[P_FNAMESIZE] ;
	/* build up the filesname */
	p_scpym(dfname, llstart->mydata->mypath, llcur->datafile, NULL) ;
	if (p_delete(dfname) == 0)
		return(TRUE) ;
	else
	{
		uDisplayText("FILE ERROR: delfile,","error in deleting file", dfname, NULL) ;
		return(FILEERR) ;
	}
}

/* cpyfile - copy from the file in origll to the file in newll 
   assume the file exists */
INT cpyfile (struct ll * newll, struct ll * outhead, struct ll * origll, struct ll * inhead)
{
	VOID * infd, * outfd ;
	INT ret ;
	TEXT infname[P_FNAMESIZE] , outfname[P_FNAMESIZE] ;
	TEXT buff [P_FMAXRSIZE], tmp[P_FMAXRSIZE+3] ;
	/* munge the filenames */
	p_scpym(infname, inhead->mydata->mypath, origll->datafile, NULL) ;
	p_scpym(outfname, outhead->mydata->mypath, newll->datafile, NULL) ;
	/* open the files */
	ret = p_open(&infd, infname, P_FTEXT | P_FSHARE) ;
	if (ret != 0)
	{
		p_errs(buff, ret) ;
		uDisplayText("FILE ERROR: cpyfile,","error in opening input", infname, buff, NULL) ;	
		return(FILEERR) ;
	}
	ret = p_open(&outfd, outfname, P_FTEXT | P_FUPDATE | P_FREPLACE) ;
	if (ret != 0)
	{
		p_errs(buff, ret) ;
		uDisplayText("FILE ERROR: cpyfile,","error in opening output", outfname, buff, NULL) ;
		p_close(infd) ;
		return(FILEERR) ;
	}
	/* copy the files */
	ret = 1 ;
	while(ret >= 0)
	{
		ret = p_read(infd, buff, P_FMAXRSIZE) ;
		if (ret < 0)
		{
			break ;
		}
		/* terminate the string */
		buff[ret] = '\0' ;
		p_scpym(tmp, "> ", buff, NULL) ;
		p_write(outfd, tmp, p_slen(tmp)) ;
	}
	/* close the files */
	p_close(infd) ;
	p_close(outfd) ;
	return(TRUE) ;
}
	
	
/* newfile, determine a safe new filename and create it */
INT newfile(struct ll * llcur, struct ll * llstart)
{
	TEXT mytempl[P_FNAMESIZE+1],  tmppath[P_FNAMESIZE+1];
	VOID * fd ;
	INT ret, i ;
	/* build up the name OUTSKELETON is assumed to contain a %d */
	p_scpym(mytempl, llstart->mydata->mypath, OUTSKELETON, NULL) ;
	for (i = 0 ; i < MAXEMAILOUT ; i ++ )
	{	
		/* basicaly run around untill we have a number for i
		   that does not corespond to a file name */
		p_atos(tmppath, mytempl, i) ;
		ret = fileexist(tmppath) ;
		if (ret == TRUE)
		{
			/* the file exists, continue */
			continue ;
		}
		else if (ret == FALSE)
		{
			/* the file does not exist */
			break ;
		}
		else
		{
			uDisplayText("FILE ERROR: newemail,","Directory, Device or other error","recieved from fileexists when testing", tmppath, NULL) ;
			return(FILEERR) ;
		}
	}
	if (i >= MAXEMAILOUT)
	{
		uDisplayText("FILE ERROR: newfile,","maximum number outgoing emails exceeded", tmppath, NULL) ;
		return(FILEERR) ;
	}
	if ((ret = p_open(&fd, tmppath, P_FCREATE | P_FTEXT)) >= 0)
	{
		p_close(fd) ;
		p_atos(llcur->datafile, OUTSKELETON, i) ;
		return(TRUE) ;
	}
	else
	{
		uDisplayText("FILE ERROR: newfile,","error in creating new file", mytempl, NULL) ;
		return(FILEERR) ;
	}
}
/* end of ancilary data file functions */

/* start of meta file operations code */
/* the meta file consists of line terminated data in the following format */
/* the full path component, E.g. LOC::M\MAIL\ */
/* mu current email adress, e.g. tim.graves@uk.sun.com the following repeated */
/* datafile name, E.g. in1.msg or out1.msg */
/* to, a list of recieved addresses, e.g. tim.graves@uk.sun.com MUST contain at least one address */
/* from, the origionator of the email */
/* subject, obvious */
/* cc, the cc list */
/* bcc, the bcc list (empty on reciept */
/* read, N if the email is unread, R if read */
/*at the end of the repeats */
/* END */
/* No other items */
/* */
/* read in the data descriptions */
INT readmeta(TEXT * fname, struct ll * itemlist)
{
	VOID * fd ;
	INT ret ;
	ret = p_open(&fd, fname, P_FTEXT | P_FSHARE) ;
	if (ret < 0)
	{
		uDisplayText("FILE ERROR:  readmeta,","error in opening", fname, NULL) ;
		return (FILEERR) ;
	}
	/* load the one off data */
	ret = getf(fd, itemlist->mydata->mypath) ;
	if ( ret == FALSE)
	{
		uDisplayText("FILE ERROR: readmeta,","error in reading my path from", fname, NULL) ;
		return(FILEERR) ;
	}
	getf(fd, itemlist->mydata->myaddr) ;
	if (ret == FALSE)
	{
		uDisplayText("FILE ERROR: readmeta,","error in reading my address from", fname, NULL) ;
		return(FILEERR) ;
	}
	while((ret = readhdr(fd, itemlist))== TRUE)
		;
	p_close(fd) ;
	if (ret == FILEERR)
	{
		uDisplayText("FILE ERROR: readmeta,","error in reading meta record from", fname, NULL) ;
		return(FILEERR) ;
	}
	return(TRUE) ;
}

/* write the data descriptions out */
INT wrtmeta(TEXT * fname, struct ll * itemlist) 
{
	VOID * fd ;
	INT ret ;
		
	ret = p_delete(fname) ; /* delete the origional file */
	if (ret < 0)
	{
		uDisplayText("FILE ERROR: wrtmeta,","error in deleting",fname,"prior to output", NULL) ;
		return(FILEERR) ;
	}
	ret = p_open(&fd, fname, P_FTEXT | P_FUPDATE | P_FREPLACE) ;
	if (ret < 0)
	{
		uDisplayText("FILE ERROR: wrtmeta,","error in opening", fname, "for output", NULL) ;
		p_close(fd) ;
		return(FILEERR) ;
	}
	/* write the one off data */
	ret = putf(fd, itemlist->mydata->mypath) ;
	if (ret == FILEERR)
	{
		uDisplayText("FILE ERROR: wrtmeta,","error in writting my path to", fname, NULL) ;
		p_close(fd) ;
		return(FILEERR) ;
	}
	ret = putf(fd, itemlist->mydata->myaddr) ;
	if (ret == FILEERR)
	{
		uDisplayText("FILE ERROR: wrtmeta,","error in writting my address to", fname, NULL) ;
		p_close(fd) ;
		return(FILEERR) ;
	}
	while(itemlist != NULL)
	{
		ret = wrthdr(fd, itemlist) ;
		if (ret == FILEERR)
			break ;
		itemlist = itemlist->next ;
	}
	if (ret == FILEERR)
	{
		uDisplayText("FILE ERROR: wrtmeta,","error in writting record to", fname, NULL) ;
		p_close(fd) ;
		return(FILEERR) ;
	}
	ret = putf(fd, "END") ;
	if (ret == FILEERR)
	{
		uDisplayText("FILE ERROR: wrtmeta,","error in writting terminator (END) to", fname, NULL) ;
		p_close(fd) ;
		return(FILEERR) ;
	}
	p_close(fd) ;
	return(TRUE) ;
}

/* read the from, subject and return path etc from the data file */
INT readhdr(VOID * fd, struct ll * itemlist)
{
	struct ll * newll ;
	TEXT datafile[20] ;
	TEXT to[HDRLEN] ;
	TEXT from[HDRLEN] ;
	TEXT subject[HDRLEN];
	TEXT cc[HDRLEN];
	TEXT bcc[HDRLEN];
	TEXT cread[HDRLEN] ;
	INT read, ret ;
	/* read in an entry */
	ret = getf(fd, datafile) ;
	if (ret == FILEERR)
	{
		uDisplayText("FILE ERROR: readhdr,","error in reading datafile", NULL) ;
		return(FILEERR) ;
	}
	if (p_scmp(datafile, "END") == 0)
		return(FALSE) ;
	ret = getf(fd, to) ;
	if (ret == FILEERR)
	{
		uDisplayText("FILE ERROR: readhdr,","error in reading to", NULL) ;
		return(FILEERR) ;
	}
	ret = getf(fd, from) ;
	if (ret == FILEERR)
	{
		uDisplayText("FILE ERROR: readhdr,","error in reading from", NULL) ;
		return(FILEERR) ;
	}
	ret = getf(fd, subject) ;
	if (ret == FILEERR)
	{
		uDisplayText("FILE ERROR: readhdr,","error in reading subject", NULL) ;
		return(FILEERR) ;
	}
	ret = getf(fd, cc) ;
	if (ret == FILEERR)
	{
		uDisplayText("FILE ERROR: readhdr,","error in reading cc", NULL) ;
		return(FILEERR) ;
	}
	ret = getf(fd, bcc) ;
	if (ret == FILEERR)
	{
		uDisplayText("FILE ERROR: readhdr,","error in reading bcc", NULL) ;
		return(FILEERR) ;
	}
	ret = getf(fd, cread) ;
	if (ret == FILEERR)
	{
		uDisplayText("FILE ERROR: readhdr,","error in reading read", NULL) ;
		return(FILEERR) ;
	}	
	if (cread[0] == 'R')
		read = RD ;
	else
		read = NEW ;
	
	/* get a new ll structure */
	newll = llnew ();
	/* fill in the structure */
	llfill(newll, datafile, to, from, subject, cc, bcc, ACTIVE, read, itemlist->count + 1) ;
	/* add the new item into the list */
	lladd(newll, itemlist) ;
	return(TRUE) ;
}
/* write a subject and destination etc to the data file */
INT wrthdr(VOID * fd, struct ll * item)
{
	INT ret ;
	/* only outut the record if its active */
	if (item->status != ACTIVE)
		return(TRUE) ;
	ret = putf(fd, item->datafile);
	if ( ret == FILEERR)
	{
		uDisplayText("FILE ERROR: wrthdr,","error in writting datafile", item->datafile, NULL) ;
		return(FILEERR) ;
	}
	ret = putf(fd, item->to) ;
	if ( ret == FILEERR)
	{
		uDisplayText("FILE ERROR: wrthdr,","error in writting to", item->to, NULL) ;
		return(FILEERR) ;
	}
	ret = putf(fd, item->from) ;
	if ( ret == FILEERR)
	{
		uDisplayText("FILE ERROR: wrthdr,","error in writting from", item->from, NULL) ;
		return(FILEERR) ;
	}
	ret = putf(fd, item->subject) ;
	if ( ret == FILEERR)
	{
		uDisplayText("FILE ERROR: wrthdr,","error in writting subject", item->subject, NULL) ;
		return(FILEERR) ;
	}
	ret = putf(fd, item->cc) ;
	if ( ret == FILEERR)
	{
		uDisplayText("FILE ERROR: wrthdr,","error in writting cc", item->cc, NULL) ;
		return(FILEERR) ;
	}
	ret = putf(fd, item->bcc) ;
	if ( ret == FILEERR)
	{
		uDisplayText("FILE ERROR: wrthdr,","error in writting bcc", item->bcc, NULL) ;
		return(FILEERR) ;
	}
	if (item->read == RD)
		ret = putf(fd, "R") ;
	else
		ret = putf(fd, "N") ;
	if ( ret == FILEERR)
	{
		uDisplayText("FILE ERROR: wrthdr,","error in writting read", item->read == RD ? "R" : "N", NULL) ;
		return(FILEERR) ;
	}
	return(TRUE) ;
}
/* end of meta file operations code */

/* start of ancillary file and keyboard IO code */
/* read a line of text from file handle */
INT getf(VOID * fd, TEXT * line)
{
	INT ret ;
	ret = p_read(fd, (VOID *) line, HDRLEN) ;
	if (ret < 0)
		return(FILEERR) ;
	line[ret] = '\0' ;

	return(TRUE) ;
}
/* write a line of text to file handle */
INT putf(VOID * fd, TEXT * line)
{
	INT ret ;
	ret = p_write(fd, (VOID *) line, p_slen(line)) ;
	if (ret < 0)
		return(FILEERR) ;

	return(TRUE) ;
}

/* end of ancillary file and keyboard IO code */
/* does the file given in fname exist return TRUE or FALSE
   if any other error than E_FILE_NXIST return FILEERR */
INT fileexist(TEXT * fname)
{
	P_INFO pinf ;
	INT ret ;
	ret = p_finfo(fname, &pinf) ;
	if (ret == 0)
	{
		return(TRUE) ;
	}
	else if (ret == E_FILE_NXIST)
	{
		return(FALSE) ;
	}
	else if ((ret == E_FILE_DEVICE) || (ret == E_FILE_NOTREADY) || (ret == E_FILE_DIR))
	{
		/* this is a major problem with the path */
		uDisplayText("FILE ERROR: fileexist,","Directory or Device does not exist", fname, NULL) ;
		return(FILEERR) ;
	}
	else /* some other unexpected error */
	{
		uDisplayText("FILE ERROR: fileexist,","unxepected error code from p_finfo", NULL) ;
		return(FILEERR) ;
	}
}
/* start of window functions */
/* Print the output list */
VOID redolist(VOID)
{
	TEXT str[100] ;
	UINT border ;
	/* print the headers around the current email */
	/* disphdrs will arrange for the current item to be bold and ITEMS_IN_LIST 
	   to be printed (if possible ) */
	disphdrs(currlist) ;
	/* do the borders, aqquire the current gc */
	gSetGC0(gchdr) ;
	/* if mailno is greater then ITEMS_IN_HALF_LIST + 1 then put an up arrow 
	   on the display if there are items on the bottom of the display */
	border = W_BORD_CUSHION|W_BORD_CORNER_4 ;
	if (mailno > (ITEMS_ON_HALF_SCREEN +1))
		border = border | W_BORD_TOP_ON ;
	else
		border = border |W_BORD_TOP_OFF ;
	/* if currlist->count - mailno is greater than ITEMS_ON_HALF_SCREEN + 1 then put a 
	   down arrow on the display */
	if (mailno < (currlist->count - ITEMS_ON_HALF_SCREEN))
		border = border |W_BORD_BOT_ON ;
	else
		border = border |W_BORD_BOT_OFF ;

	gBorder(border) ;
	/* update the status message */
	p_atos(str, "%s, Mail no %d of %d", currlist == inlist ? "Incomming list" : "Outgoing List", mailno, currlist->count) ;
	statusmsg(str) ;
}
	

VOID statusmsg(TEXT * str)
{
	TEXT tmp[300] ;
	/* get hold of the current context */
	gSetGC0(gcstatus) ;
	/* sometimes the border gets trashed so rederw it */
	gBorder(W_BORD_CUSHION|W_BORD_CORNER_4) ;
	p_scpym(tmp, str, blank, NULL) ;
	gPrintClipText(5,12,tmp, p_slen(tmp), 220) ;
}

INT askincl()
{
	struct ll * llptr ;
	INT ret ;
	
	/* only include the current email if mailno is valid */
	llptr = llnofind(mailno, currlist) ;
	if (llptr == NULL)
		return(FALSE) ;
	uOpenDialog("Include Current Email ?") ;
	uAddButtonList("Yes", 'y', "No", 'n', NULL) ;
	ret = uRunDialog() ;
	if (ret == 'y')
		return(TRUE) ;
	else
		return(FALSE) ;
}
